import type { HydrationState, Router as RemixRouter } from "../router/router";
import type { AssetsManifest, FutureConfig } from "./ssr/entry";
import type { RouteModules } from "./ssr/routeModules";
export type WindowReactRouterContext = {
    basename?: string;
    state: HydrationState;
    criticalCss?: string;
    future: FutureConfig;
    isSpaMode: boolean;
    stream: ReadableStream<Uint8Array> | undefined;
    streamController: ReadableStreamDefaultController<Uint8Array>;
    a?: number;
    dev?: {
        port?: number;
        hmrRuntime?: string;
    };
};
export interface ViewTransition {
    finished: Promise<void>;
    ready: Promise<void>;
    updateCallbackDone: Promise<void>;
    skipTransition(): void;
}
declare global {
    var __staticRouterHydrationData: HydrationState | undefined;
    var __reactRouterVersion: string;
    interface Document {
        startViewTransition(cb: () => Promise<void> | void): ViewTransition;
    }
    var __reactRouterContext: WindowReactRouterContext | undefined;
    var __reactRouterManifest: AssetsManifest | undefined;
    var __reactRouterRouteModules: RouteModules | undefined;
    var __reactRouterInstance: RemixRouter | undefined;
    var __reactRouterHdrActive: boolean;
    var __reactRouterClearCriticalCss: (() => void) | undefined;
    var $RefreshRuntime$: {
        performReactRefresh: () => void;
    } | undefined;
}
export {};
